#[doc = "Register `TTCAN_CAPTURE` reader"]
pub struct R(crate::R<TTCAN_CAPTURE_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<TTCAN_CAPTURE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<TTCAN_CAPTURE_SPEC>> for R {
    fn from(reader: crate::R<TTCAN_CAPTURE_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `TTCAN_CAPTURE` writer"]
pub struct W(crate::W<TTCAN_CAPTURE_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<TTCAN_CAPTURE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<TTCAN_CAPTURE_SPEC>> for W {
    fn from(writer: crate::W<TTCAN_CAPTURE_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `SYNC_MARK` reader - copy TTCAN_COUNTER.LOCAL_TIME to TTCAN_CAPTURE.SYNC_MARK, when SOF detected.?when new event triggers, new LOCAL_TIME value will overwrite previous SYNC_MARK value"]
pub struct SYNC_MARK_R(crate::FieldReader<u16, u16>);
impl SYNC_MARK_R {
    pub(crate) fn new(bits: u16) -> Self {
        SYNC_MARK_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for SYNC_MARK_R {
    type Target = crate::FieldReader<u16, u16>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 16:31 - copy TTCAN_COUNTER.LOCAL_TIME to TTCAN_CAPTURE.SYNC_MARK, when SOF detected.?when new event triggers, new LOCAL_TIME value will overwrite previous SYNC_MARK value"]
    #[inline(always)]
    pub fn sync_mark(&self) -> SYNC_MARK_R {
        SYNC_MARK_R::new(((self.bits >> 16) & 0xffff) as u16)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "TTCAN Level1 capture configuration\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ttcan_capture](index.html) module"]
pub struct TTCAN_CAPTURE_SPEC;
impl crate::RegisterSpec for TTCAN_CAPTURE_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [ttcan_capture::R](R) reader structure"]
impl crate::Readable for TTCAN_CAPTURE_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [ttcan_capture::W](W) writer structure"]
impl crate::Writable for TTCAN_CAPTURE_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets TTCAN_CAPTURE to value 0"]
impl crate::Resettable for TTCAN_CAPTURE_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
